>From e39bb3de3ff8816d5adbc72ac80d03f34bbfecfa Mon Sep 17 00:00:00 2001
From: Martin Nagy <mnagy@redhat.com>
Date: Thu, 8 Oct 2009 21:18:30 +0200
Subject: [PATCH] Delete sssd-i18n.h and put it's old contents into util.h

Also include talloc.h, tevent.h and ldb.h as system headers in util.h.
---
 server/Makefile.am         |    1 -
 server/monitor/monitor.c   |    1 -
 server/tools/sss_useradd.c |    1 -
 server/tools/tools_util.h  |    2 +-
 server/util/server.c       |    1 -
 server/util/sssd-i18n.h    |   29 -----------------------------
 server/util/util.h         |   12 +++++++++---
 7 files changed, 10 insertions(+), 37 deletions(-)
 delete mode 100644 server/util/sssd-i18n.h

diff --git a/server/Makefile.am b/server/Makefile.am
index 81f438d..c9f2d46 100644
--- a/server/Makefile.am
+++ b/server/Makefile.am
@@ -236,7 +236,6 @@ dist_noinst_HEADERS = \
     monitor/monitor.h \
     util/nss_sha512crypt.h \
     util/dlinklist.h \
-    util/sssd-i18n.h \
     util/util.h \
     util/strtonum.h \
     util/sss_ldap.h \
diff --git a/server/monitor/monitor.c b/server/monitor/monitor.c
index 427e10d..56bf6ea 100644
--- a/server/monitor/monitor.c
+++ b/server/monitor/monitor.c
@@ -52,7 +52,6 @@
 #include "dbus/dbus.h"
 #include "sbus/sssd_dbus.h"
 #include "monitor/monitor_interfaces.h"
-#include "util/sssd-i18n.h"
 
 /* ping time cannot be less then once every few seconds or the
  * monitor will get crazy hammering children with messages */
diff --git a/server/tools/sss_useradd.c b/server/tools/sss_useradd.c
index f805b24..d05f5ae 100644
--- a/server/tools/sss_useradd.c
+++ b/server/tools/sss_useradd.c
@@ -31,7 +31,6 @@
 #include "db/sysdb.h"
 #include "tools/tools_util.h"
 #include "tools/sss_sync_ops.h"
-#include "util/sssd-i18n.h"
 
 /* Default settings for user attributes */
 #define CONFDB_DFL_SECTION "config/user_defaults"
diff --git a/server/tools/tools_util.h b/server/tools/tools_util.h
index a56fc5e..92fba20 100644
--- a/server/tools/tools_util.h
+++ b/server/tools/tools_util.h
@@ -25,7 +25,7 @@
 
 #include <popt.h>
 
-#include "util/sssd-i18n.h"
+#include "util/util.h"
 
 #define CHECK_ROOT(val, prg_name) do { \
     val = getuid(); \
diff --git a/server/util/server.c b/server/util/server.c
index e8daf87..3a84c70 100644
--- a/server/util/server.c
+++ b/server/util/server.c
@@ -29,7 +29,6 @@
 #include <fcntl.h>
 #include <unistd.h>
 #include "util/util.h"
-#include "util/sssd-i18n.h"
 #include "ldb.h"
 #include "confdb/confdb.h"
 
diff --git a/server/util/sssd-i18n.h b/server/util/sssd-i18n.h
deleted file mode 100644
index 73b1c80..0000000
--- a/server/util/sssd-i18n.h
+++ /dev/null
@@ -1,29 +0,0 @@
-/*
-    Authors:
-        Stephen Gallagher <sgallagh@redhat.com>
-
-    Copyright (C) 2009 Red Hat
-
-    This program is free software; you can redistribute it and/or modify
-    it under the terms of the GNU General Public License as published by
-    the Free Software Foundation; either version 3 of the License, or
-    (at your option) any later version.
-
-    This program is distributed in the hope that it will be useful,
-    but WITHOUT ANY WARRANTY; without even the implied warranty of
-    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-    GNU General Public License for more details.
-
-    You should have received a copy of the GNU General Public License
-    along with this program.  If not, see <http://www.gnu.org/licenses/>.
-*/
-
-#ifndef _SSSD_I18N_H
-#define _SSSD_I18N_H
-
-#include <locale.h>
-#include <libintl.h>
-#define _(STRING) gettext (STRING)
-#include "config.h"
-
-#endif
diff --git a/server/util/util.h b/server/util/util.h
index a9d2553..9a27ae5 100644
--- a/server/util/util.h
+++ b/server/util/util.h
@@ -27,19 +27,25 @@
 #include <unistd.h>
 #include <string.h>
 #include <errno.h>
+#include <libintl.h>
 #include <limits.h>
+#include <locale.h>
 #include <time.h>
 #include <pcre.h>
+
 #include "config.h"
-#include "talloc.h"
-#include "tevent.h"
-#include "ldb.h"
+
+#include <talloc.h>
+#include <tevent.h>
+#include <ldb.h>
 
 #ifndef HAVE_ERRNO_T
 #define HAVE_ERRNO_T
 typedef int errno_t;
 #endif
 
+#define _(STRING) gettext (STRING)
+
 extern const char *debug_prg_name;
 extern int debug_level;
 extern int debug_timestamps;
-- 
1.6.2.5